Today, many KZbinrs are only focused on sharing more materials, without considering how companies are asking questions or how freshers can really face interviews. Great work by Striver and GFG for providing practical advice on these topics.
@avtarchandra24072 жыл бұрын
Here i can see Arjit is struggling to get approach in the very start that clearly shows a real feel to interview ...a nice video to learn a lot from thank you @striver for such gem content ❤️❤️.....I want to know how you choose interviewee?
@lokanathpatasahani8972 жыл бұрын
We need more such type of mock interviews
@momidimidhilesh829 Жыл бұрын
First thought comes to mind after seeing this question is Coin Change. 1. Find first 3 primes(precompute primes if given lot of queries) 2. BFS to get minimum primes
@rajrajesh16696 ай бұрын
BFS or DFS ?! Coin Change problem can be solved by DFS.
@hello_everybody-sm6xi5 ай бұрын
@@rajrajesh1669 BFS we can use
@DEBJYOTIRAY-hl6ip5 ай бұрын
why do we need bfs? just apply the coin change problem and the coins available are all the prime numbers upto the given target limit
@aayushverma41392 жыл бұрын
Sieve of eratosthenes + dp on subsequences
@reamerx4 ай бұрын
Sieve is enough without dp Generating prime number till 10 Will make a cnt aswell Then return the cnt directly
@rohitraj58322 жыл бұрын
The very first intuition i got after seeing the question was that , first i will prepare M primes in some array/vector. Then i can relate this qn. to unbounded knapsack problem (coin change problem where I've to find minimum number of denominations to make Target price). Or target sum problem to find minimum number of elements to make target . Striver Dp series helped me alot to think out of the box also ❤️❤️. thanks @striver
@sudityagupta91932 жыл бұрын
I thought the same approach bro
@heisenberg3488 Жыл бұрын
in same I thought
@yashaneypvt Жыл бұрын
Same
@pulkitjain5159 Жыл бұрын
ya the same thing i realted it to , and same with help of striver's dp series . but don't you think the constraints are too tight.
@Groot1306 Жыл бұрын
same thought process bro....
@apnachannelnitp183311 ай бұрын
Mixture of Sieve and Knapsack.
@arkamukherjee3962 Жыл бұрын
Brute force of this solution that strike in my mind is making a vector to store all the m primes and after that use unbounded knapsack to find minimun number of prime to make n
@chandannikhil85262 жыл бұрын
For brute force approach we can tell that storing ist M prime no in array then simple do combination sum where duplicacy allowed that is we can use same element again T.c : exponential S.c O(M)
@maremandasreekrishna85792 жыл бұрын
I am thinking of same approach when i first saw problem
@jaysingh14572 жыл бұрын
I also thought of the same approach
@sudeepbattu55252 жыл бұрын
Minimum coin change with repetions allowed and the array filled with first M primes
@AyushGupta-kb9iv2 жыл бұрын
minimum coin required + seive
@debapratimshyam1492 жыл бұрын
I think what he was talking at the end about functions is "Pure Functions". Changing a global variable from within a function is a "Side effect" and it's a bad practice to do that unless absolutely necessary. Pure functions should not have any side effects and given a set of input you can be rest assured that the output will always be the same no matter how many times the function is called.
@vijaykumarbille77277 ай бұрын
Clearly understood 💯...How companies approach a fresher
@Noob_Coder12344 ай бұрын
after seeing the second test case it was pretty simple to undeerstand that there are so many ways so when many ways comes it comes to recursion and then we can move for dp also
@noedie49732 жыл бұрын
thanks! lot to learn here even if you get the question by yourself.
@idontKNOW-pb9hs2 жыл бұрын
So inspiring men striver you are really great!!!
@suvigyabasnotra73782 жыл бұрын
Show us an interview as well where the candidate barely knows anything...!
@suvigyabasnotra73782 жыл бұрын
But still clears it...!
@takeUforward2 жыл бұрын
Scripted karne bol rahe ho 😂
@suvigyabasnotra73782 жыл бұрын
@@takeUforward Just kisi random CS student ka interview lene ko... jahan usey kuchh na aata ho... which would reflect the reality for most students. 😂
@madetolaugh34762 жыл бұрын
@@takeUforward bahi...video aayi nhi yrrr...subah se wait kar rahe hain
@tonystonks44892 жыл бұрын
@@suvigyabasnotra7378 realistically someone with no knowledge won't clear the OA of MAANG level companies and won't get a chance of interview.
@krishmakhija83335 ай бұрын
i think quetion can be easily solved using lower bound concept. in nlogn complexity.
@swapyswap5887 Жыл бұрын
binary search lower bound 1st que
@venky301119 ай бұрын
Million dollar DSA problem - Given k, X and a stream of numbers , determine the average of the last k numbers , excluding the largest X numbers
@varunmanchanda39722 жыл бұрын
Coin Change variation where coins are M, and target sum is N, and how come 5+3+2 is 11 ?
@HariKrishnan-ff4hf2 жыл бұрын
5+3+3=11 . We can take infinite supplies.
@objectofmathematics2 жыл бұрын
@striver@GeeksforGeeks if N
@kasiruyamagata77162 жыл бұрын
No the qn is minimum numbers of prime numbers less than m is required to sum up to n This qn is quite similar to coin change
@aamirhannan890 Жыл бұрын
@@kasiruyamagata7716yeah! I could relate this to the coin change with infinite supply!
@captainmcduckyYT2 жыл бұрын
If they're asking this level of questions for an OA. Then I won't even make it to the interviews lol.
@anujbajpai57913 ай бұрын
I think most people puzzled with the solution as it was iterative approach, doing the memoization way would have been easy to absorb
@anirbanghosh96112 жыл бұрын
Definitely top notch content
@aditkaushal93975 ай бұрын
sieve of eratosthenes + dp on subsequences(coin change problem modified)
@honeyyadav9767 Жыл бұрын
What about we use bfs algorithm? Like simply store first m primes in a queue and then just simply keep iterating until you get the value
@HamzaSayyed4044 ай бұрын
Any similar question to practice ? (Dp + sieves combination)
@itz_ritzu6 ай бұрын
What if we find first M primes using a Sieve, and then use a recursion on that list with a constraint of M[prime] < N ? that would just take around O(n) time asymptotically? (I'm not sure Im solving it as I see the question 1st time so I'll update later). Lets take an example: Say I take N=10 and M=1. So my M list is: M[]={2} //since 1st prime is M Now of course here 10%2 is 0 so it works (we can do 10/2 to see how many 2's we need) For the next problem: N=11 M=3 So my M list is: M[]={2,3,5} //3 primes Here, we can see M[3] < N //and M is strictly increasing list so we don't need to check more We see 11%5 !=0 We store 5 in a list say K. So we subtract 5 from 11 i.e. 6 and call this same function on 6 with M[]={2,3}, and concatenate the output on K[]. so what I mean is we get 5 first, then we send 6, so we have M[]={2,3} so we check 6%3 and its 0 so we do 6/3 to see how many 3's we need. So finally we get {5,3,3} is that correct? lemme check P.S. the answer is 5,3,2 in the doc and it seems my disappointment is immeasurable, and my day is ruined.
@as_if4 ай бұрын
Last time I checked this video, I was scared. This time, I'm still scared. Phak, I have made no improvement
@higgsboson674 ай бұрын
After how long did you rewatch ?
@VishnuKumar-fo2rl Жыл бұрын
yaar itna time kaha dete hain wo log bas 5-10 min and btw ye question 10 min ka hai baki aap jaisa interviewer milega to badhiya kismat
@manojkr7554 Жыл бұрын
25:00
@niteshsaxena10662 ай бұрын
do all companies ask CP based questions?....as sieve is a CP topic
@sonakshibajpai64455 ай бұрын
very useful !
@anushk_iitg5 ай бұрын
7:33 LOL, sieve of.....what !!? 😂
@sudhiranjangupta75172 жыл бұрын
Unbound Knapsack ... Dekhte hi bola 😂😂😂
@prantobala85055 ай бұрын
Can anyone give a test case where gready fail?
@AdityaSingh-ui4tr2 жыл бұрын
Store all possible M primes in an array in the sorted order then start subtracting given N from last element of the array e.g. if N=19 is given and M is 3 then arr[]{2,3,5} 19%(last element in arr)= 4 now the main twist comes if I go with second last element then it will give me 1 as remainder which isn't a prime number we cannot add this number in our solution array. so if the remainder is 1 we have to switch to 3rd last element which is 2 : 19/5=3 + (19%5/2)=2= 3+2=5. I've not checked all testcases correct me if I'm wrong.
@kunalaggarwal38672 жыл бұрын
Your approach is good, but it won't work on numerous testcase. One of testcase is the sample testcase included in the video where N = 11 and M = 3, the prime array would be {2,3,5}. Now according to your solution we need to do 11%5 = 1, which is false since we only need 5 once and then 3 twice.
@hrithikeshmylatty80112 жыл бұрын
This solution + backtracking will work I guess. When remainder becomes 1, undo the operation by adding the current prime number once to the reminder. Then repeat the process with the next smaller prime number till remainder becomes 0.
@codingaspirant94462 жыл бұрын
Loved it Sir ❤❤❤
@vishwaratnasharma21402 жыл бұрын
Is it possible .. to get the the list or all M primes and thn apply Target sum and count minimum counts
@abhinavraj13385 ай бұрын
Yess
@we2riruruirirfj Жыл бұрын
similar to combination sum
@sastapasta86924 ай бұрын
Can You Add These Questions To GFG, I Have Prepared Solution For Few But Can't Find An Online Judge To Check Them I Don't Wanna See The Solution Mentioned In The Video As I Wanna Approach To Correct Answer Myself. Please Add Them
@kushalswarup26622 жыл бұрын
7:35 whaaaat
@yeshwanthvatti2200 Жыл бұрын
Sieve of erathosthenes.
@noobchess25165 ай бұрын
can we do sieve and binary search on search to get lower bound till n=0 if anyway in mid way lower bound out of sieve return -1
@krishmakhija83335 ай бұрын
ya but if by subtracting you go 1 then at that time add one instance of last lower bound number and do ans--
@himanshukandwal87102 жыл бұрын
why he just started with tabulation i.e most optimal approach rather giving bruteforce approach first, at 22:02
@takeUforward2 жыл бұрын
There is no generic rule to problems which are not standard ones.
@raj00610 ай бұрын
At 7:34 which thing he mentioned he can use to find first n primes?
@sakshamShukla_9 ай бұрын
sieve of eratosthenes
@mandavasairaghavendradines658211 ай бұрын
2+3+5 is 10 right. Why he told its 11?
@atharvak15036 ай бұрын
5, 3, 3
@swatantrapatel76082 жыл бұрын
❤️❤️
@kasiruyamagata77162 жыл бұрын
This qn is similar to coin change
@prabhattiwari0078 ай бұрын
Striver se sikh ke striver ko interview dene ka maza hi alag h😂
@shivamsolanki91535 ай бұрын
I also solver the question but take an hour 🙁
@anirbanc882 жыл бұрын
i don't get the first question, what does it mean? help?
@KurumiddeKezia3 ай бұрын
hello
@mukulbansal82693 ай бұрын
kabhi kisi ko amazon ko amahzin bolte suna hai
@ArpitGJoshi3 ай бұрын
agar esa hota hai to meri job toh lagne se rahi😰😰😭
@SanjanaSingh-mc6re2 жыл бұрын
Why can't we use greedy approach here? Like for N=11 and M=3, I could have started from the biggest prime no. that's gonna be 5 and subtract that value from N and update value of N until I don't get value of N less than the current prime no or value of N==current prime no+1. In that case, I will move towards the smaller prime no and try to do the same thing with that. If N!=0 then we can't make N with the help of first M prime no.
@shardendushekharchaubey55822 жыл бұрын
You'll also have to handle an edge case like n=4, m=2 Or n=6 m=3
@shardendushekharchaubey55822 жыл бұрын
Here greedy can give -1 because from 4, it'll subtract 3, then 1 remains which is not possible.... So we'll have to add a condition that after the subtraction, the remaining no. Should not be 1
@tanishapandey51563 ай бұрын
import java.util.*; class HelloWorld { static boolean a[]; static ArrayList b=new ArrayList(); public static void solve(int n,int m) { Arrays.fill(a,true); int o=0; for(int i=2;ib.get(i)) { ans+=(n/b.get(i)-1); n=n%b.get(i)+b.get(i); } } System.out.println(ans); } } I checked for these edge cases and it is working can you let me know any case in which it is failing
@kartiknagrale14793 ай бұрын
@@shardendushekharchaubey5582 after subtracting if its 0 we got answer, but if we get 1 then don't take it, move towards smaller prime.
@namansharma7531 Жыл бұрын
Step1: Make an array with first M prime numbers Step2: Use unbounded knapsack code: import java.util.*; class Solution { public static int minPrimes(int N, int M) { int[] arr = findPrimes(M); int ans = unbounded_Knapsack(arr, N); return ans; } public static int unbounded_Knapsack(int[] nums, int N) { int len = nums.length; int[][] t = new int[len + 1][N + 1]; for (int i = 0; i
@frickofunky20082 жыл бұрын
his voice was shaking
@vishnuvarunthorthi6 ай бұрын
test
@shamsulhaque552 жыл бұрын
All fake and bogus
@Sushank7772 жыл бұрын
Are you good at problem solving?
@shamsulhaque552 жыл бұрын
@@Sushank777 No one is !
@Sushank7772 жыл бұрын
@@shamsulhaque55 stfu... those who work hard to improve problem solving skills are good at it... So, go first improve yourself it's better than criticising someone who is 1000X better than you. Btw what's your codechef or codeforces profile?
@dakshsinghrathore95842 жыл бұрын
🤣
@ojasdighe9912 жыл бұрын
@@shamsulhaque55 i am
@bharathraj93312 жыл бұрын
How can I get a chance to give a live mock with striver?? @striver @take U forward